# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP Audits Domain Commands"""

from typing import List
from typing_extensions import NotRequired, TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..network.types import RequestId
    from .types import GenericIssueDetails

class GetEncodedResponseParameters(TypedDict):
    requestId: "RequestId"
    """Identifier of the network request to get content for."""
    encoding: "str"
    """The encoding to use."""
    quality: "NotRequired[float]"
    """The quality of the encoding (0-1). (defaults to 1)"""
    sizeOnly: "NotRequired[bool]"
    """Whether to only return the size information (defaults to false)."""


class GetEncodedResponseReturns(TypedDict):
    body: "str"
    """The encoded body as a base64 string. Omitted if sizeOnly is true. (Encoded as a base64 string when passed over JSON)"""
    originalSize: "int"
    """Size before re-encoding."""
    encodedSize: "int"
    """Size after re-encoding."""



class CheckContrastParameters(TypedDict, total=False):
    reportAAA: "bool"
    """Whether to report WCAG AAA level issues. Default is false."""





class CheckFormsIssuesReturns(TypedDict):
    formIssues: "List[GenericIssueDetails]"
